%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   imageCreation.m: generates plots and images from 
%   the data output of main*.m 
%   Michelangelo Bin & Thomas Parisini
%   24 November 2020
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% This file reads the output data generated by the files main*.m and
% builds images and visualisations from them.


%% 1. Settings

% Data path
DATA_PATH = './data';

% Files to open
files ={'simout_1','simout_2','simout_3','simout_4','simout_5','simout_6'};
N_FILES = numel(files);

% Color map
COL_S = [0 0 .7];
COL_E = [1 1 0];
COL_I = [1 0 0];
COL_Q = .6*[1 1 1];
COL_R = .6*[.5 1 .5];
COL_V = [.5 .1 .5];
COL_eI = [0 0 0];    

% This is only needed for names of strategies
SM=SamplingManager(false,false);

fprintf('\n Plotting %d simulation clusters',N_FILES);

%% 2. Data retrival and image creation

% Initialise boxplots
BOXPLOT_SETTINGS ={
    {4,"Infected"}
    {8,"Cumulative Infected"} 
    {7,"Quarantined"}
    {6,"Vaccinated"}
};

N_BOXPLOTS = size(BOXPLOT_SETTINGS,1);
BOXPLOT_DATA = cell(N_BOXPLOTS,2);
for b = 1:N_BOXPLOTS
    BOXPLOT_DATA{b}{1}=[];
    BOXPLOT_DATA{b}{2}=[];
end

 
% Initialise timeseries plots
Figures = cell(N_FILES,1);
Axes = cell(N_FILES,1);


for s=1:N_FILES
    
    fprintf('\n Cluster %d:\n\t file: %s',s,strcat(DATA_PATH,'/',files{s}));
    
    clearvars -except DATA_PATH files N_FILES COL_S COL_E COL_I COL_Q ...
        COL_R COL_V COL_eI s SM...
        BOXPLOT_SETTINGS N_BOXPLOTS BOXPLOT_DATA...
        Figures Axes
    
    load(strcat(DATA_PATH,'/',files{s}));
     
    fprintf('\n\t number of subclusters: %d',EXT_M);
       
    Figures{s}= cell(EXT_M,1);
    Axes{s}= cell(EXT_M,2);
 
    for i=1:EXT_M
        
        fprintf('\n\t subcluster %d\n\t  Phase 1: %s\n\t  - Phase 2: %s',...
            i,SM.TEST_MODE_STRINGS(1+EXT_simulation_data{i}(1)),...
            SM.TEST_MODE_STRINGS(1+EXT_simulation_data{i}(2)));
        
        % Template of EXT_output:
        %   EXT_output{EXT_i}{EXT_n}={
        %             Time;nS;nE;nI;nR;nV;nQ;everI;...
        %             R0;db_bub_inst;...
        %             avg_n;max_n;med_n;avg_v;max_v;med_v;...
        %             n_daily_quarantined;n_daily_positive_tests;n_daily_tested;...
        %             n_daily_quarantined;n_daily_vaccinated;ratio_positive_tests;...
        %             Phases
        %         }; 
        
        % Initialise figures
        Figures{s,i} = figure('units','normalized','position',[.05 .26 .8 .5]);
        
        Axes{s,i,1}=axes('position',[0.05 0.08 .4 .8]);
        box(Axes{s,i,1},'on');
        Axes{s,i,2}=axes('position',[0.55 0.08 .4 .8]);
        box(Axes{s,i,2},'on');
        tits = SM.TEST_MODE_STRINGS(EXT_simulation_data{i}(1)+1)+" + "+SM.TEST_MODE_STRINGS(EXT_simulation_data{i}(2)+1);
        title(Axes{s,i,1},tits);
        title(Axes{s,i,2},tits);
        
        % Time & number of repetitions
        Time = EXT_output{i}{1}{1}; 
        Ri = EXT_simulation_data{i}(4);
        
        % Here we plot the timeseries of all the simulations and we 
        % compute the mean timeseries and the box plot data
        meanI = zeros(size(Time));
        meaneI = zeros(size(Time));
        meanRo = zeros(size(Time));
                
        boxp_peaks = nan(Ri,N_BOXPLOTS); 
        
        for j=1:Ri
            
            % Timeseries data and plots
            meanI  = meanI + EXT_output{i}{j}{4}/N;
            meaneI = meaneI + EXT_output{i}{j}{8}/N;
            meanRo = meanRo + EXT_output{i}{j}{9};
            hold(Axes{s,i,1},'on');
            plot(Axes{s,i,1},Time,EXT_output{i}{j}{4}/N,'linewidth',1,'color',[.7 .7 .7]);
            hold(Axes{s,i,1},'on');
            plot(Axes{s,i,1},Time,EXT_output{i}{j}{8}/N,'linewidth',1,'color',[.7 .7 .7]);
            hold(Axes{s,i,2},'on');
            plot(Axes{s,i,2},Time,EXT_output{i}{j}{9},'linewidth',1,'color',[.7 .7 .7]);
            
            % Boxplot data
            if EXT_simulation_data{i}(1)~=SamplingManager.NOTESTING || EXT_simulation_data{i}(2)~=SamplingManager.NOTESTING
                for b=1:N_BOXPLOTS
                    boxp_peaks(j,b) = max(EXT_output{i}{j}{BOXPLOT_SETTINGS{b}{1}}/N);
                end
            end
        end
        
        meanI = meanI./Ri;
        meaneI = meaneI./Ri;
        meanRo = meanRo./Ri;
        
        % Boxplot data
        if EXT_simulation_data{i}(1)~=SamplingManager.NOTESTING || EXT_simulation_data{i}(2)~=SamplingManager.NOTESTING
            boxp_abbrv = SM.TEST_MODE_ABBREV(EXT_simulation_data{i}(1)+1)+"+"+SM.TEST_MODE_ABBREV(EXT_simulation_data{i}(2)+1);
            for b=1:N_BOXPLOTS
                BOXPLOT_DATA{b}{1} = [BOXPLOT_DATA{b}{1};boxp_peaks(:,b)];
                BOXPLOT_DATA{b}{2} = [BOXPLOT_DATA{b}{2};repmat({boxp_abbrv},Ri,1)];
            end
        end
        
        % Plot the means
        hold(Axes{s,i,1},'on');
        plot(Axes{s,i,1},Time,meanI,'linewidth',2,'color',COL_I);
        hold(Axes{s,i,1},'on');
        plot(Axes{s,i,1},Time,meaneI,'linewidth',2,'color',COL_eI);
        hold(Axes{s,i,2},'on');
        plot(Axes{s,i,2},Time,meanRo,'linewidth',2,'color',COL_S);
        xlim(Axes{s,i,1},[Time(1) Time(end)]);
        ylim(Axes{s,i,1},[0 1]);
        xlim(Axes{s,i,2},[Time(1) Time(end)]); 
         
        
        
    end
    
end

%% Boxplot 
BoxPlotFig = cell(N_BOXPLOTS,1);
BoxPlotAxes = cell(N_BOXPLOTS,1);

for b=1:N_BOXPLOTS
    BoxPlotFig{b} = figure('units','normalized','position',[.1 .2 .6 .5]);
    BoxPlotAxes{b} = axes(BoxPlotFig{b});
    box(BoxPlotAxes{b},'on');
    boxplot(BoxPlotAxes{b},BOXPLOT_DATA{b}{1},BOXPLOT_DATA{b}{2});
    title(BoxPlotAxes{b},strcat('BoxPlot ',BOXPLOT_SETTINGS{b}{2}));
end



